git-clone.shon commit git-push: fix --tags and document it. (42301e3)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, Linus Torvalds
   4# Copyright (c) 2005, Junio C Hamano
   5# 
   6# Clone a repository into a different directory that does not yet exist.
   7
   8# See git-sh-setup why.
   9unset CDPATH
  10
  11usage() {
  12        echo >&2 "Usage: $0 [--naked] [-l [-s]] [-q] [-u <upload-pack>] [-o <name>] [-n] <repo> [<dir>]"
  13        exit 1
  14}
  15
  16get_repo_base() {
  17        (cd "$1" && (cd .git ; pwd)) 2> /dev/null
  18}
  19
  20if [ -n "$GIT_SSL_NO_VERIFY" ]; then
  21    curl_extra_args="-k"
  22fi
  23
  24http_fetch () {
  25        # $1 = Remote, $2 = Local
  26        curl -nsfL $curl_extra_args "$1" >"$2"
  27}
  28
  29clone_dumb_http () {
  30        # $1 - remote, $2 - local
  31        cd "$2" &&
  32        clone_tmp='.git/clone-tmp' &&
  33        mkdir -p "$clone_tmp" || exit 1
  34        http_fetch "$1/info/refs" "$clone_tmp/refs" || {
  35                echo >&2 "Cannot get remote repository information.
  36Perhaps git-update-server-info needs to be run there?"
  37                exit 1;
  38        }
  39        while read sha1 refname
  40        do
  41                name=`expr "$refname" : 'refs/\(.*\)'` &&
  42                case "$name" in
  43                *^*)    ;;
  44                *)
  45                        git-http-fetch -v -a -w "$name" "$name" "$1/" || exit 1
  46                esac
  47        done <"$clone_tmp/refs"
  48        rm -fr "$clone_tmp"
  49}
  50
  51quiet=
  52use_local=no
  53local_shared=no
  54no_checkout=
  55upload_pack=
  56naked=
  57origin=origin
  58while
  59        case "$#,$1" in
  60        0,*) break ;;
  61        *,-n|*,--no|*,--no-|*,--no-c|*,--no-ch|*,--no-che|*,--no-chec|\
  62        *,--no-check|*,--no-checko|*,--no-checkou|*,--no-checkout)
  63          no_checkout=yes ;;
  64        *,--na|*,--nak|*,--nake|*,--naked) naked=yes ;;
  65        *,-l|*,--l|*,--lo|*,--loc|*,--loca|*,--local) use_local=yes ;;
  66        *,-s|*,--s|*,--sh|*,--sha|*,--shar|*,--share|*,--shared) 
  67          local_shared=yes; use_local=yes ;;
  68        *,-q|*,--quiet) quiet=-q ;;
  69        1,-o) usage;;
  70        *,-o)
  71                git-check-ref-format "$2" || {
  72                    echo >&2 "'$2' is not suitable for a branch name"
  73                    exit 1
  74                }
  75                origin="$2"; shift
  76                ;;
  77        1,-u|1,--upload-pack) usage ;;
  78        *,-u|*,--upload-pack)
  79                shift
  80                upload_pack="--exec=$1" ;;
  81        *,-*) usage ;;
  82        *) break ;;
  83        esac
  84do
  85        shift
  86done
  87
  88# --naked implies --no-checkout
  89test -z "$naked" || no_checkout=yes
  90
  91# Turn the source into an absolute path if
  92# it is local
  93repo="$1"
  94local=no
  95if base=$(get_repo_base "$repo"); then
  96        repo="$base"
  97        local=yes
  98fi
  99
 100dir="$2"
 101# Try using "humanish" part of source repo if user didn't specify one
 102[ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*/||g')
 103[ -e "$dir" ] && echo "$dir already exists." && usage
 104mkdir -p "$dir" &&
 105D=$(cd "$dir" && pwd) &&
 106case "$naked" in
 107yes) GIT_DIR="$D" ;;
 108*) GIT_DIR="$D/.git" ;;
 109esac && export GIT_DIR && git-init-db || usage
 110case "$naked" in
 111yes)
 112        GIT_DIR="$D" ;;
 113*)
 114        GIT_DIR="$D/.git" ;;
 115esac
 116
 117# We do local magic only when the user tells us to.
 118case "$local,$use_local" in
 119yes,yes)
 120        ( cd "$repo/objects" ) || {
 121                echo >&2 "-l flag seen but $repo is not local."
 122                exit 1
 123        }
 124
 125        case "$local_shared" in
 126        no)
 127            # See if we can hardlink and drop "l" if not.
 128            sample_file=$(cd "$repo" && \
 129                          find objects -type f -print | sed -e 1q)
 130
 131            # objects directory should not be empty since we are cloning!
 132            test -f "$repo/$sample_file" || exit
 133
 134            l=
 135            if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
 136            then
 137                    l=l
 138            fi &&
 139            rm -f "$GIT_DIR/objects/sample" &&
 140            cd "$repo" &&
 141            find objects -depth -print | cpio -puamd$l "$GIT_DIR/" || exit 1
 142            ;;
 143        yes)
 144            mkdir -p "$GIT_DIR/objects/info"
 145            {
 146                test -f "$repo/objects/info/alternates" &&
 147                cat "$repo/objects/info/alternates";
 148                echo "$repo/objects"
 149            } >"$GIT_DIR/objects/info/alternates"
 150            ;;
 151        esac
 152
 153        # Make a duplicate of refs and HEAD pointer
 154        HEAD=
 155        if test -f "$repo/HEAD"
 156        then
 157                HEAD=HEAD
 158        fi
 159        (cd "$repo" && tar cf - refs $HEAD) |
 160        (cd "$GIT_DIR" && tar xf -) || exit 1
 161        ;;
 162*)
 163        case "$repo" in
 164        rsync://*)
 165                rsync $quiet -av --ignore-existing  \
 166                        --exclude info "$repo/objects/" "$GIT_DIR/objects/" &&
 167                rsync $quiet -av --ignore-existing  \
 168                        --exclude info "$repo/refs/" "$GIT_DIR/refs/" || exit
 169
 170                # Look at objects/info/alternates for rsync -- http will
 171                # support it natively and git native ones will do it on the
 172                # remote end.  Not having that file is not a crime.
 173                rsync -q "$repo/objects/info/alternates" \
 174                        "$GIT_DIR/TMP_ALT" 2>/dev/null ||
 175                        rm -f "$GIT_DIR/TMP_ALT"
 176                if test -f "$GIT_DIR/TMP_ALT"
 177                then
 178                    ( cd "$D" &&
 179                      . git-parse-remote &&
 180                      resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
 181                    while read alt
 182                    do
 183                        case "$alt" in 'bad alternate: '*) die "$alt";; esac
 184                        case "$quiet" in
 185                        '')     echo >&2 "Getting alternate: $alt" ;;
 186                        esac
 187                        rsync $quiet -av --ignore-existing  \
 188                            --exclude info "$alt" "$GIT_DIR/objects" || exit
 189                    done
 190                    rm -f "$GIT_DIR/TMP_ALT"
 191                fi
 192                ;;
 193        http://*)
 194                clone_dumb_http "$repo" "$D"
 195                ;;
 196        *)
 197                cd "$D" && case "$upload_pack" in
 198                '') git-clone-pack $quiet "$repo" ;;
 199                *) git-clone-pack $quiet "$upload_pack" "$repo" ;;
 200                esac || {
 201                        echo >&2 "clone-pack from '$repo' failed."
 202                        exit 1
 203                }
 204                ;;
 205        esac
 206        ;;
 207esac
 208
 209cd "$D" || exit
 210
 211if test -f "$GIT_DIR/HEAD"
 212then
 213        head_points_at=`git-symbolic-ref HEAD`
 214        case "$head_points_at" in
 215        refs/heads/*)
 216                head_points_at=`expr "$head_points_at" : 'refs/heads/\(.*\)'`
 217                mkdir -p "$GIT_DIR/remotes" &&
 218                echo >"$GIT_DIR/remotes/origin" \
 219                "URL: $repo
 220Pull: $head_points_at:$origin" &&
 221                git-update-ref "refs/heads/$origin" $(git-rev-parse HEAD) &&
 222                (cd "$GIT_DIR" && find "refs/heads" -type f -print) |
 223                while read ref
 224                do
 225                        head=`expr "$ref" : 'refs/heads/\(.*\)'` &&
 226                        test "$head_points_at" = "$head" ||
 227                        test "$origin" = "$head" ||
 228                        echo "Pull: ${head}:${head}"
 229                done >>"$GIT_DIR/remotes/origin"
 230        esac
 231
 232        case "$no_checkout" in
 233        '')
 234                git checkout
 235        esac
 236fi